- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | List of all members
Xapian::Query Class Reference

Class representing a query. More...

## Public Types
enum | op { OP_AND, OP_OR, OP_AND_NOT, OP_XOR, OP_AND_MAYBE, OP_FILTER, OP_NEAR, OP_PHRASE, OP_VALUE_RANGE, OP_SCALE_WEIGHT, OP_ELITE_SET, OP_VALUE_GE, OP_VALUE_LE, OP_SYNONYM }
| Enum of possible query operations. More...

## Public Member Functions
| Query (const Query &copyme)
| Copy constructor. More...
Query & | operator= (const Query &copyme)
| Assignment. More...
| Query ()
| Default constructor: makes an empty query which matches no documents. More...
| ~Query ()
| Destructor. More...
| Query (const std::string &tname_, Xapian::termcount wqf_=1, Xapian::termpos pos_=0)
| A query consisting of a single term. More...
| Query (Query::op op_, const Query &left, const Query &right)
| A query consisting of two subqueries, opp-ed together. More...
| Query (Query::op op_, const std::string &left, const std::string &right)
| A query consisting of two termnames opp-ed together. More...
template<class Iterator >
| Query (Query::op op_, Iterator qbegin, Iterator qend, Xapian::termcount parameter=0)
| Combine a number of Xapian::Query-s with the specified operator. More...
| Query (Query::op op_, Xapian::Query q, double parameter)
| Apply the specified operator to a single Xapian::Query object, with a double parameter.
| Query (Query::op op_, Xapian::valueno slot, const std::string &begin, const std::string &end)
| Construct a value range query on a document value. More...
| Query (Query::op op_, Xapian::valueno slot, const std::string &value)
| Construct a value comparison query on a document value. More...
| Query (Xapian::PostingSource *external_source)
| Construct an external source query. More...
Xapian::termcount | get_length () const
| Get the length of the query, used by some ranking formulae. More...
TermIterator | get_terms_begin () const
| Return a Xapian::TermIterator returning all the terms in the query, in order of termpos. More...
TermIterator | get_terms_end () const
| Return a Xapian::TermIterator to the end of the list of terms in the query.
bool | empty () const
| Test if the query is empty (i.e. More...
std::string | serialise () const
| Serialise query into a string. More...
std::string | get_description () const
| Return a string describing this object.

## Static Public Member Functions
static Query | unserialise (const std::string &s)
| Unserialise a query from a string produced by serialise(). More...
static Query | unserialise (const std::string &s, const Registry &registry)
| Unserialise a query from a string produced by serialise(). More...

## Static Public Attributes
static const Xapian::Query | MatchAll
| A query which matches all documents in the database. More...
static const Xapian::Query | MatchNothing
| A query which matches no documents. More...

## Detailed Description

Class representing a query.

Queries are represented as a tree of objects.

## Member Enumeration Documentation

enum Xapian::Query::op

Enum of possible query operations.

Enumerator
OP_AND | Return iff both subqueries are satisfied.
OP_OR | Return if either subquery is satisfied.
OP_AND_NOT | Return if left but not right satisfied.
OP_XOR | Return if one query satisfied, but not both.
OP_AND_MAYBE | Return iff left satisfied, but use weights from both.
OP_FILTER | As AND, but use only weights from left subquery.
OP_NEAR | Find occurrences of a list of terms with all the terms occurring within a specified window of positions. Each occurrence of a term must be at a different position, but the order they appear in is irrelevant. The window parameter should be specified for this operation, but will default to the number of terms in the list.
OP_PHRASE | Find occurrences of a list of terms with all the terms occurring within a specified window of positions, and all the terms appearing in the order specified. Each occurrence of a term must be at a different position. The window parameter should be specified for this operation, but will default to the number of terms in the list.
OP_VALUE_RANGE | Filter by a range test on a document value.
OP_SCALE_WEIGHT | Scale the weight of a subquery by the specified factor. A factor of 0 means this subquery will contribute no weight to the query - it will act as a purely boolean subquery. If the factor is negative, Xapian::InvalidArgumentError will be thrown.
OP_ELITE_SET | Pick the best N subqueries and combine with OP_OR. If you want to implement a feature which finds documents similar to a piece of text, an obvious approach is to build an "OR" query from all the terms in the text, and run this query against a database containing the documents. However such a query can contain a lots of terms and be quite slow to perform, yet many of these terms don't contribute usefully to the results. The OP_ELITE_SET operator can be used instead of OP_OR in this situation. OP_ELITE_SET selects the most important ''N'' terms and then acts as an OP_OR query with just these, ignoring any other terms. This will usually return results just as good as the full OP_OR query, but much faster. In general, the OP_ELITE_SET operator can be used when you have a large OR query, but it doesn't matter if the search completely ignores some of the less important terms in the query. The subqueries don't have to be terms, but if they aren't then OP_ELITE_SET will look at the estimated frequencies of the subqueries and so could pick a subset which don't actually match any documents even if the full OR would match some. You can specify a parameter to the query constructor which control the number of terms which OP_ELITE_SET will pick. If not specified, this defaults to 10 (or `ceil(sqrt(number_of_subqueries))` if there are more than 100 subqueries, but this rather arbitrary special case will be dropped in 1.3.0). For example, this will pick the best 7 terms:
                Xapian::Query query(Xapian::Query::OP_ELITE_SET, subqs.begin(), subqs.end(), 7);
If the number of subqueries is less than this threshold, OP_ELITE_SET behaves identically to OP_OR.
OP_VALUE_GE | Filter by a greater-than-or-equal test on a document value.
OP_VALUE_LE | Filter by a less-than-or-equal test on a document value.
OP_SYNONYM | Treat a set of queries as synonyms. This returns all results which match at least one of the queries, but weighting as if all the sub-queries are instances of the same term: so multiple matching terms for a document increase the wdf value used, and the term frequency is based on the number of documents which would match an OR of all the subqueries. The term frequency used will usually be an approximation, because calculating the precise combined term frequency would be overly expensive. Identical to OP_OR, except for the weightings returned.

## Constructor & Destructor Documentation

Xapian::Query::Query | ( | const Query & | copyme | ) |

Copy constructor.

Xapian::Query::Query | ( |  | ) |

Default constructor: makes an empty query which matches no documents.

Also useful for defining a Query object to be assigned to later.

An exception will be thrown if an attempt is made to use an undefined query when building up a composite query.

Xapian::Query::~Query | ( |  | ) |

Destructor.

Xapian::Query::Query | ( | const std::string & | tname_,
|  | Xapian::termcount | wqf_ = `1`,
|  | Xapian::termpos | pos_ = `0`
| ) |  |

A query consisting of a single term.

Xapian::Query::Query | ( | Query::op | op_,
|  | const Query & | left,
|  | const Query & | right
| ) |  |

A query consisting of two subqueries, opp-ed together.

Xapian::Query::Query | ( | Query::op | op_,
|  | const std::string & | left,
|  | const std::string & | right
| ) |  |

A query consisting of two termnames opp-ed together.

template<class Iterator >

Xapian::Query::Query | ( | Query::op | op_,
|  | Iterator | qbegin,
|  | Iterator | qend,
|  | Xapian::termcount | parameter = `0`
| ) |  |

Combine a number of Xapian::Query-s with the specified operator.

The Xapian::Query objects are specified with begin and end iterators.

AND, OR, XOR, ELITE_SET, SYNONYM, NEAR and PHRASE can take any number of subqueries. Other operators take exactly two subqueries.

The iterators may be to Xapian::Query objects, pointers to Xapian::Query objects, or termnames (std::string-s).

For NEAR and PHRASE, a window size can be specified in parameter.

For ELITE_SET, the elite set size can be specified in parameter.

Xapian::Query::Query | ( | Query::op | op_,
|  | Xapian::valueno | slot,
|  | const std::string & | begin,
|  | const std::string & | end
| ) |  |

Construct a value range query on a document value.

A value range query matches those documents which have a value stored in the slot given by slot which is in the range specified by begin and end (in lexicographical order), including the endpoints.

Parameters

  op_ | The operator to use for the query. Currently, must be OP_VALUE_RANGE.
  slot | The slot number to get the value from.
  begin | The start of the range.
  end | The end of the range.

Xapian::Query::Query | ( | Query::op | op_,
|  | Xapian::valueno | slot,
|  | const std::string & | value
| ) |  |

Construct a value comparison query on a document value.

This query matches those documents which have a value stored in the slot given by slot which compares, as specified by the operator, to value.

Parameters

  op_ | The operator to use for the query. Currently, must be OP_VALUE_GE or OP_VALUE_LE.
  slot | The slot number to get the value from.
  value | The value to compare.

Xapian::Query::Query | ( | Xapian::PostingSource * | external_source | ) |
| explicit

Construct an external source query.

An attempt to clone the posting source will be made immediately, so if the posting source supports clone(), the source supplied may be safely deallocated after this call. If the source does not support clone(), the caller must ensure that the posting source remains valid until the Query is deallocated.

Parameters

  external_source | The source to use in the query.

## Member Function Documentation

bool Xapian::Query::empty | ( |  | ) | const

Test if the query is empty (i.e.

was constructed using the default ctor or with an empty iterator ctor).

Xapian::termcount Xapian::Query::get_length | ( |  | ) | const

Get the length of the query, used by some ranking formulae.

This value is calculated automatically - if you want to override it you can pass a different value to Enquire::set_query().

TermIterator Xapian::Query::get_terms_begin | ( |  | ) | const

Return a Xapian::TermIterator returning all the terms in the query, in order of termpos.

If multiple terms have the same term position, their order is unspecified. Duplicates (same term and termpos) will be removed.

Query& Xapian::Query::operator= | ( | const Query & | copyme | ) |

Assignment.

std::string Xapian::Query::serialise | ( |  | ) | const

Serialise query into a string.

The query representation may change between Xapian releases: even between minor versions. However, it is guaranteed not to change unless the remote database protocol has also changed between releases.

static Query Xapian::Query::unserialise | ( | const std::string & | s | ) |
| static

Unserialise a query from a string produced by serialise().

This method will fail if the query contains any external PostingSource leaf nodes.

Parameters

  s | The string representing the serialised query.

static Query Xapian::Query::unserialise | ( | const std::string & | s,
|  | const Registry & | registry
| ) |  |
| static

Unserialise a query from a string produced by serialise().

The supplied registry will be used to attempt to unserialise any external PostingSource leaf nodes. This method will fail if the query contains any external PostingSource leaf nodes which are not registered in the registry.

Parameters

  s | The string representing the serialised query.
  registry | Xapian::Registry to use.

## Member Data Documentation

const Xapian::Query Xapian::Query::MatchAll
| static

A query which matches all documents in the database.

const Xapian::Query Xapian::Query::MatchNothing
| static

A query which matches no documents.

The documentation for this class was generated from the following file:

- xapian/query.h